#ifndef GAME_SERVER_PLAYER_H
#define GAME_SERVER_PLAYER_H

// this include should perhaps be removed
#include "entities/character.hpp"

// player object
class PLAYER
{
	MACRO_ALLOC_POOL_ID()
private:
	CHARACTER *character;
public:
	PLAYER(int client_id);
	~PLAYER();

	// TODO: clean this up
	char skin_name[64];
	int use_custom_color;
	int color_body;
	int color_feet;
	
	int respawn_tick;
	int die_tick;
	//
	bool spawning;
	int client_id;
	int team;
	int score;
	bool force_balanced;
	
	//
	int vote;
	int64 last_votecall;

	//
	int64 last_chat;
	int64 last_setteam;
	int64 last_changeinfo;
	int64 last_emote;
	int64 last_kill;

	// network latency calculations	
	struct
	{
		int accum;
		int accum_min;
		int accum_max;
		int avg;
		int min;
		int max;	
	} latency;
	
	// this is used for snapping so we know how we can clip the view for the player
	vec2 view_pos;

	void init(int client_id);
	
	CHARACTER *get_character();
	
	void kill_character(int weapon);

	void try_respawn();
	void respawn();
	void set_team(int team);
	
	void tick();
	void snap(int snapping_client);

	void on_direct_input(NETOBJ_PLAYER_INPUT *new_input);
	void on_predicted_input(NETOBJ_PLAYER_INPUT *new_input);
	void on_disconnect();

	char start_name[MAX_NAME_LENGTH];

	bool join_frozen;
	bool frozen;

	vec2 camp_pos;
	bool camp_sent;

	int melt_tick;
	int automelt_tick;
	int camp_tick;
	int spawn_tick;
	int freeze_tile_tick;

	int last_input;

	bool melters[MAX_CLIENTS];
	bool being_thawed_sent;
	void melt(int melter);
	int is_melted();

	void remove_chr(bool strict);

	int killstreak;
	bool award;

	void reset();

	void give(int type);

	bool is_chatting;

	// Stats
	int s_shots;
	int s_kills;
	int s_deaths;
	int s_hits;
	//	flagball
	int num_owngoals;	//	counter for own-goals
	bool owngoal_warned;	//	own goal warning (only shown once)
};

#endif
